// Licensed to ClickHouse, Inc. under one or more contributor
// license agreements. See the NOTICE file distributed with
// this work for additional information regarding copyright
// ownership. ClickHouse, Inc. licenses this file to you under
// the Apache License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

package proto

import (
	"fmt"
	chproto "github.com/ClickHouse/ch-go/proto"
)

type TableColumns struct {
	First  string
	Second string
}

func (t *TableColumns) Decode(reader *chproto.Reader, revision uint64) (err error) {
	if t.First, err = reader.Str(); err != nil {
		return err
	}
	if t.Second, err = reader.Str(); err != nil {
		return err
	}
	return nil
}

func (t *TableColumns) String() string {
	return fmt.Sprintf("first=%s, second=%s", t.First, t.Second)
}
